// C++ code
// Team 10_1 Project2 
// Cargo Depositing Robot 
// Jo, Ruben, Dani, Nandini, Fahad
 
#include <Servo.h>
// define sensor variables 
int duration; 
int distance;

// define motor pins
 int AIN1a = 13; 
int AIN2a = 12;
int PWMAa = 11;


//button 
int buttonpin = 2;
int buttval;

//  servo pin 
int servopin = 3;

// sesnor pins
int trigPin=5;
int echoPin=6;

// define servo positions 
int open = 0; // position for open clamp 
int closed = 90; // position for closed clamp 
  
Servo myservo; 

void setup()
 
{
  pinMode(buttonpin, INPUT_PULLUP);
  pinMode(AIN1a, OUTPUT);
  pinMode(AIN2a, OUTPUT);
  pinMode(PWMAa, OUTPUT);
  
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  
  // set servo 
  myservo.attach(servopin);
  Serial.begin(9600);
  
  myservo.write(closed);

}

void loop()
{
   buttval = digitalRead(buttonpin);
  distance = getDistance();

  if (buttval == LOW){ // button pressed 
   
    while (distance > 50){
    digitalWrite(AIN1a, HIGH); // Set H-bridge Input 1 high
  	digitalWrite(AIN2a, LOW); 
    analogWrite(PWMAa, 150); 

    distance=getDistance();
  
    // say how far it is   
  Serial.print("Distance: ");
  Serial.print(distance);
  Serial.println(" cm");
    }
    
  // Check if an object is within a the range 
  if (distance < 50){
    // Stop the motor
    digitalWrite(AIN1a, LOW); // stop spinning 
  	digitalWrite(AIN2a, LOW); 
    analogWrite(PWMAa, 0); 
    
    delay(4000);
    
   myservo.write(open);
    
    delay(5000);
    
    myservo.write(closed);
  }

 }
}

float getDistance()
{
  float echoTime;                   //variable to store the time it takes for a ping to bounce off an object
  float calculatedDistance;         //variable to store the distance calculated from the echo time

  //send out an ultrasonic pulse that's 10ms long
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  echoTime = pulseIn(echoPin, HIGH);      //use the pulsein command to see how long it takes for the
                                                                        //pulse to bounce back to the sensor

  calculatedDistance = echoTime / 148.0;  //calculate the distance of the object that reflected the pulse
                                                                           // (half the bounce time multiplied by the speed of sound)

  return calculatedDistance;              //send back the distance that was calculated
}
